;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; AutoText
;
; AUTOTEXT liefert ein dynamisches Textelement, da das Plotdatum oder
; den Dateinamen immer aktuell in der Zeichnung anzeigt. Hierzu wird der
; entsprechende Steuercode fr das aus den AutoCAD-ExpressTools bekannte
; RTEXT-Element automatisch erzeugt. Der Benutzer kann einfach aus einer
; Liste von Mglichkeiten (Dateiname mit/ohne Pfadangabe, aktuelles Datum
; in verschiedenen Formaten) auswhlen.;
;
; Aufruf: autotext
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; (c) Dipl.-Ing.  Volker Kleppel
; http://www.cadwerk.com
; vkleppel@gmx.de
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
; Version: 1.5                      Datum: 01.01.2000
; AutoCAD12   [ ]  AutoCAD14   [x]  AutoCAD2000(i) [x]   
; AutoCAD2002 [x]  AutoCAD2004 [x]  AutoCAD2005    [x]
; Freeware    [x]  Shareware   [ ]
;-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=


(defun c:AutoText (/ tColor tSize tStyle tRot cont mode vc dump)

  (if (AcetRText:appload)
    (progn
  (initget 128 "Dateiname daTum")
  (setq	dump
	 (getkword
	   "\nWelche Information soll ausgegeben werden: daTum/<Dateiname>?"
	 )
  )

  (if (= dump "daTum")
    (progn
      (initget 128 "tMjj ttmmJj tmjjjj Ttmmjjjj")
      (setq dump
	     (getkword
	       "\nAusgabeformat des Datum? tMjj/ttmmJj/tmjjjj/<Ttmmjjjj>"
	     )
      )

      (setq cont (cond
		   ((= dump "tMjj") "$(edtime, $(getvar,date), D\".\"M\".\"YY)")
		   ((= dump "ttmmJj") "$(edtime, $(getvar,date), DD\".\"MO\".\"YY)" )
		   ((= dump "tmjjjj") "$(edtime, $(getvar,date), D\".\"M\".\"YYYY)")
		   ((= dump "Ttmmjjjj") "$(edtime, $(getvar,date), DD\".\"MO\".\"YYYY)")
		   ((= dump nil) "$(edtime, $(getvar,date), DD\".\"MO\".\"YYYY)")
		   (T nil)
		 )
      )
    )
    (progn
      (initget 128 "Dateiname dateiPfad Beides")
      (setq
	dump (getkword
	       "\nDateiinformationen? Dateiname/dateiPfad/<Beides>"
	     )
      )

      (setq cont (cond
		   ((= dump "Dateiname") "$(getvar, \"dwgname\")")
		   ((= dump "dateiPfad") "$(getvar, \"dwgprefix\")")
		   ((= dump "Beides")
		    "$(getvar, \"dwgprefix\")\\$(getvar, \"dwgname\")"
		   )
		   ((= dump nil)
		    "$(getvar, \"dwgprefix\") $(getvar, \"dwgname\")"
		   )
		   (T nil)
		 )
      )

    )
  )
  (setq	tColor (getvar "DIMCLRT")
	tSize  (* (getvar "DIMTXT") (getvar "DIMSCALE"))
	vc     (getvar "VIEWCTR")
	tstyle (getvar "TEXTSTYLE")
	trot   0.0
	mode   1
  )
  
  (entmake (list '(0 . "RTEXT")
		 '(100 . "AcDbEntity")
		 '(100 . "RText")
		 (cons 10 (trans vc 1 0))
		 (cons 40 tSize)
		 (cons 7 tStyle)
		 (cons 50 tRot)
		 (cons 1 cont)
		 (cons 70 mode)
		 (cons 62 tColor)
	   )
  )

  (command "_move" (entlast) "" vc pause)
  )
    (princ "\nDie notwendigen ARX-Dateien fr den Befehl konnten nicht geladen werden!")
    )
  (print)
  
)

(defun AcetRText:appload ()
  (if (member nil (mapcar
                   '(lambda (x) (if (member x (arx)) T (arxload x nil)))
                   '("acetutil.arx" "rtext.arx") ) )
    nil
    T
  )
)


(princ "\nAutoText - (c) Dipl.-Ing. V. Kleppel, www.cadwerk.com")
(princ "\nAufruf: autotext")
(print)